// Triggers for the script at minimum should be NetworkChange, and immediate start.
// if this is only to be done in one or more locations, than location change should also be used.

DisplayTriggerParameters();

// Disable Modem and Wireless if Wired is connected
// Disable Modem and Wired if Wireless is connected
// Disable Wired and Wireless if Dialup is connection
// Reenable all hardware (based off policy settings) if there are NO active network connections

//NOTE:  The order for checking sets the precedence for allowed connections
//	 As coded below, Wired is first, then Wireless, then Modem.  So if
//	 you have both a wired and modem connection when this script is
//	 launched, then the modem will be disabled (i.e. the wired is preferred)

var CurLoc = Query.SecurityLocation.Name.toLowerCase();
Action.Trace("CurLoc is: " + CurLoc);
if (CurLoc ==  "desired location")
{
   // only run this script if the user is in the desired location.  
   // This MUST MATCH the exact name, lower cased of the location in the policy
   // if it is not the desired location, than cleanup script values
   var lastLoc = Storage.GetNameValue("CurrentLocation");
   if (lastLoc != "")
   {
       Storage.SetNameValue("CurrentLocation", "");
       CleanupScriptPolicy();
   }
}
else
{
    Storage.SetNameValue("CurrentLocation", CurLoc);

    var Wired = Query.IsAdapterTypeConnected("wired");
    Action.Trace("Connect Status of Wired is: " + Wired);

    var Wireless = Query.IsAdapterTypeConnected("wireless");
    Action.Trace("Connect Status of Wireless is: " + Wireless );

    var Dialup = Query.IsAdapterTypeConnected("modem");
    Action.Trace("Connect Status of Dialup is: " + Dialup );

    var wiredDisabled = Query.IsHardwareDisabled("wired");
    Action.Trace("Query on WiredDisabled is: " + wiredDisabled );

    var wifiDisabled = Query.IsHardwareDisabled("wireless");
    Action.Trace("Query on WifiDisabled is: " + wifiDisabled );

    var dialupDisabled = Query.IsHardwareDisabled("modem");;
    Action.Trace("Query on DialupDisabled is: " + dialupDisabled );

    //check if there is a wired connection
    if (Wired)
    {
	    Action.Trace ("Wired Connection Only!");
        Action.SetHardwareEnforcement("wireless", "disable");
        Action.SetHardwareEnforcement("modem", "disable");
    }
    else
    {
	    Action.Trace("NO Wired connection found.");

        //check if there is a wireless connection
        if (Wireless)
        {
	        Action.Trace ("Wireless Connection Only!");
            Action.SetHardwareEnforcement("wired", "disable");
            Action.SetHardwareEnforcement("modem", "disable");
        }
        else
        {
	        Action.Trace("NO Wireless connection found.");

            //check if there is a modem connection
            if (Dialup)
            {
	            Action.Trace ("Modem Connection Only!");
                Action.SetHardwareEnforcement("wired", "disable");
                Action.SetHardwareEnforcement("wireless", "disable");
            }
            else
            {
	            Action.Trace("NO modem connection found.");
            
                if (( !Wired ) && ( !Wireless ) && ( !Dialup ))
                {   //Apply inherit so you don't override policy settings
	                Action.Trace("NO connections so, return to policy all");
                    CleanupScriptPolicy();
                }
            }
        }
    }
}

function CleanupScriptPolicy()
{
    Action.SetHardwareEnforcement("wired", "inherit");
    Action.SetHardwareEnforcement("wireless", "inherit");
    Action.SetHardwareEnforcement("modem", "inherit");
}

function DisplayTriggerParameters()
{
    Action.Trace("");
    Action.Trace(" ******** Trigger Parameters ********* ");
    Action.Trace("");
    Action.Trace("Reason = " + Query.TriggerParameter("reason"));
    Action.Trace("Parameter Count = " + Query.TriggerParameterCount);
    for(var idx = 0; idx < Query.TriggerParameterCount; idx++)
    {
        Action.Trace("Parameter: " + Query.TriggerParameterName(idx) + " -> " + Query.TriggerParameterValue(idx));
    }
}



